----------------------------
-- yoke © nico@yokerp.com --
----------------------------

local concat,format = table.concat,string.format
local db = {}

function db:main()
  local act = params.act
  if act == 'save' then
    if not self.user.admin then return 'Admin only' end
    if (params.hted or "") == "" then return "error:empty content" end
    --local file = concat{self.conf.path,"/apps/",params.templ or "",".html"}--todo
    local file = concat{"apps/",params.templ or "",".html"}
    local fd = io.open(file,'w')
    if fd and fd:write(params.hted) then return {'ok'} end
    return concat{'Error write to file:',file}
  elseif act == 'pdf' then
    local body = params.htpdf
    local data = self.conf.data
    local pdf = concat{data,"/out/",params.smod or "",params.recno,".pdf"}
    local htm = concat{pdf,".htm"}
    local fd = io.open(htm,"w")
    if not fd or not body then return {concat{"error content:",body}} end
    fd:write(concat{format([[<html><head><meta charset='utf8'/>
    <link rel='stylesheet' href='%s/site/face/css/yoke.css' type='text/css'/>
    <style>div {background:white;} body{background:white;}</style>
   </head><body>]],self.conf.path),body,"</body></html>"})
    fd:close()
    local wk = self.conf.wkhtmltopdf or "wkhtmltopdf"
    local cmd = concat{wk," ",htm," ",pdf}
    if not os.execute(cmd) then
      os.remove(htm)
      return {concat{"error:",cmd}}
    end
    fd = io.open(pdf,'rb')
    local out = ''
    if fd then
      out = fd:read("*a")
      if not params.send then
        local fname=concat{"attachment;filename=\"",params.smod or "doc",params.recno or "",".pdf\""}
        header("Content-Disposition",fname)
        header("Content-Type","application/pdf")
      end
    end
    os.remove(htm)
    os.remove(pdf)
    return {out}
  elseif act then
    if not self.user.admin then return 'Admin only' end
    act = self.util.url.decode(act)
    local path = concat{"apps/",act,".html"}
    local fd = io.open(path)
    if not fd then
      fd = io.open(concat{self.conf.path,"/",path})
    end
    return {jsed=fd and fd:read("*a") or concat{path,' not found'}}
  end
  return true
end


local save = string.format([[<div style="float:right;">
  <form id="edfrm" action = "javascript:save();" method="post">
    <input id="hted" type="hidden" name="hted"/>
    <input type="submit" value="%s" />
  </form></div>
]],lang.Save or "Save")

local close = string.format([[<div style="float:right;margin-left:3px;">
<input type="button" value="%s" onclick="window.close();$('#pdf_modal').modal('toggle');"/>
</div>
]],lang.Close or "Close")

--toggleStamp also for document in sale invoice

local pdf = format([[<div style="display:inline-block;">
  <form id="pdf" method="post" onsubmit="return jsht('htpdf');"
        action='$uri' enctype="multipart/form-data">
    <input name="mod" type="hidden" value="%s"/>
    <input name="recno" type="hidden" value="%s"/>
    <input name="act" type="hidden" value="%s"/>
    <input id="htpdf" type="hidden" name="htpdf"/>
    <input type="submit" value="%s" />
    <input name='stamp' type='checkbox' onclick="toggleStamp()"/>
  </form></div>
]],params.mod,params.recno,params.act,lang.PDF or "PDF")

local send = format([[<input type="button"
      onclick="javascript:send('$uri',{mod:'%s',recno:'%s',act:'%s'})"
      value="%s" />
]],params.mod,params.recno,params.act,lang.Send or "Send")

local paper = format([[<input type="button"
      onclick="javascript:paper('$uri',{mod:'%s',recno:'%s',act:'%s'})"
      value="%s" />
]],params.mod,params.recno,params.act,lang.Print or "Print")

local form = format('<input type="button" onclick="templ();" value="%s" />',lang.Form or "Form")

function db:jsed(target,content,uri)
  local jsed = require"yoke.site.apps.page.html.edit"
  local ed = (target == "hted" or not target)
  pdf = string.gsub(pdf,"%$([%d%w]+)",uri or "yoke.lua")
  paper = string.gsub(paper,"%$([%d%w]+)",uri or "yoke.lua")
  if target ~= "view" or not uri then
    jsed = concat{jsed.css,jsed.edit,jsed.content} 
  else
    if target == 'view' then target = 'hted' end
    send = string.gsub(send,"%$([%d%w]+)",uri or "yoke.lua")
    local view = string.format(jsed.view,concat{pdf,paper,send,close})
    jsed = concat{jsed.css,view,jsed.content} 
  end

  return string.gsub(jsed,"%$([%d%w]+)",{
    save = ed and not params.paper and concat{close,save} or (uri and close or ''),
    print = ed and paper or "",
    form = ed and form  or "",
    pdf = ed and pdf or "",
    target = target or "hted",
    content = content or "<!--yoke-->Loading...", -- for html toggle
    toggle = target and concat{target,"Toggle"} or "",
  })
end

return db

