------------------------------
-- yoke (c) nico@yokerp.com --
------------------------------
local sha256 = require'sha256'

local db = {}
local concat,insert = table.concat,table.insert

db.user = {menu={}}

local access = {
  {1,'User'},
  {2,'Site'},
}

db.view = {
  {"login", "Login",   sz = 25,constraint="unique"},--1
  {"pw",    "Password",sz = 25,ht = 'PW'},--2
  {"active","Access",  ht = "SELECT",rf=access},--3
  {"lang",  "Lang", ht = "SELECT",rf = 'langs'},--4
  {"menu",  "Menu", ht = 'SELECT',rf={{'left',"Left"},{'top','Top'}}},--5
  {"admin", "Admin",ht = 'CHECKBOX'},--6
  {"home" , "Home", ht = "SELECT", rf = {{"home",ht="SHOW"}},rt="pages"},--7
  {'role',  "Role", ht = "SELECT",rt="roles"},--8
  {"signature","Signature",ht="TEXTAREA"},--9
  {"cookie"},--10
}

db.list = {
  {"login","Login",ht='SELF'},
  {'roles.name', "Role", ht = "REF"},
  {"admin","Admin",ht = 'CHECKBOX'},
  {"active","Active",ht="CHECKBOX",ed=true},
  join = {"roles on users.role = roles.rowid"},
  where = {
    {'login','Login',fd='login'},
    {'active','Active',ht='CHECKBOX'}
  },
}


db.field = {
  home = function(self,row)
    local sel = {}
    local qry = {"select id,name from pages where active = 1 and access > 1 and menu+0 > 0 "}
    if row and (tonumber(row.role) or 0) > 0 then
      for role in self.conn:urows("select pages from roles where rowid = "..row.role) do
        local pages = {}
        for pg in string.gmatch(role,"(%w+):0") do pages[#pages+1] = pg end
        if #pages > 0 then
          insert(qry,concat{" and id not in ('",concat(pages,"','"),"')"})
        end
      end
    end
    insert(qry," order by menu")
    for id,name in self.conn:urows(concat(qry)) do
      insert(sel,{id,name,(row and id == row.home) and true})
    end
    return sel
  end,
}

function db:update(row)
  if row.pw and string.len(row.pw) ~= 64 then
    row.pw = sha256(row.pw)
  end
end

function db:menu(row)
  if not row then
    local menu = {}
    for _,app in ipairs(self.conf.site) do
      local conf = require(concat{"yoke.site.apps.",app[1],".conf"})
      for _,mod in ipairs(conf) do
        local id,name = mod[1],mod[2]
        if not mod.off and id ~= "users" then insert(menu,{id,name}) end
      end
    end
    return menu
  end
end

function db.user:init(row)
  db.user.id = row.rid
  db.user.admin = row.admin == 1 and true or false
  db.user.pages = row.pages
  db.user.login = row.login

  db.user.home = (row.home and row.home ~= "") and row.home
  if row.lang ~= '' and row.lang ~= self.conf.lang then
    self.conf.lang = row.lang
    if row.lang == 'en' then lang = {}
    else
        pcall(require(concat{"yoke.site.apps.page.lang.",self.conf.lang}))
        for _,app in ipairs(self.conf.apps) do
          if app[2] then pcall(require,concat{"apps.",app[1],".lang.",self.conf.lang}) end
        end
    end
  end
  db.user.person = row.person
  db.user.menu.top = ((row.menu == 'top') or (self.conf.userface and row.menu ~= 'left'))
  return db.user
end

function db.user:enter()
    if self.conf.autologin and not params.uname then
      params.uname = self.conf.autologin
      params.pw = self.conf.autologin
    end
    local uname = string.gsub(params.uname or '',"'","''")
    local pw = string.gsub(params.pw or '',"'","''")
    local msg = 'Invalid username'
    local qry = concat{"select users.login,users.pw,users.admin,ifnull(users.lang,'') as lang,",
    "roles.pages,users.rowid as rid,home,hex(randomblob(25)) as key,menu from users ",
    "left join roles on users.role = roles.rowid where users.active = 1 and login = '",uname,"'"}
    for row in self.conn:nrows(qry) do
      local key = row.key
      if row.pw ~= pw and row.pw ~= sha256(pw) then
        msg = 'Invalid password'
        break 
      end
      local qry = concat{"update users set cookie = '",key,"' where rowid = ",row.rid}
      if self.conn:exec(qry) == 0 then
        cookie("yokeid",key)
        self.user:init(row)
        return 'ok'
      else
        return self.conn:errmsg()
      end
    end
    return msg
end

function db:main()
  if not self.user.admin then return end
  if params.act == "new" then
    for num in self.conn:urows("select max(rowid)+1 from users") do
      params.login = num
    end
  end
end

return db
