------------------------------
-- yoke © luamani@yahoo.com --
------------------------------

local class = require'snap.class'
local db = class('yoke')
local tins,concat,format = table.insert,table.concat,string.format
table.class = class

function db:run()--name,mod

  local dbg = {}
  local cli = self.conf.cli
  local out = {}

  if self.def.main then
    local result = self.def:main(out,mod)
    if result then
      if cli and type(result) == 'table' and result[1] then
        print(result[1])
      end
      return result
    end
  end
  if not params then params = {} end
  local act,rec = params.act,tonumber(params.recno)
  if type(act) == "table" then
    act = act[1]
  end
--
  --if self.field and type(self.field) == 'table' and type(self.field[1]) == 'function' and not self.field.done then
  -- self.field[1](self) -- extended field todo
  --  self.field.done = true
  --end
  local mes = {}
  if act == "update" then
    rec = self:bind("save"):run(rec,mes)
    if (tonumber(rec) or 0) == 0 or params.cbox then
      if self.conf.js then
        return {concat(mes)} -- popup
      else
        return concat(mes)
      end
    end
    local pmod,prec = params.pmod,params.prec
    if pmod and prec then
      params = {}
      params.mod = pmod
      params.recno = prec
      params.act = 'show'
      return self:page(pmod,true) --todo check sub
    end
  end

  if cli then
    if act == "finder" then self:bind("list"):finder(cli) return end
  elseif (params.fmod ~= self.model and not params.prn) or not self.conf.js then
    if (self:access(self.model,nil,self.user.id,"list") or
        self:access(self.model,nil,self.user.id,"new")) then
      if self.user.guest and self.user.guest.finder == false then
        out.finder = ''
        params.fmod = self.model -- todo ords in guest list
      else
        out.finder = self:bind("list"):finder() or ''
      end
    else
      out.finder = ''
    end
  end

  local view = self.def.view
  if act == 'new' and self.def.defaults then
    self.def:defaults()
  end

  if act == 'new' or act == 'show' or act == 'update' or act == 'edit' then
    if view.finder == 'off' then
      out.finder = ""
    elseif view.finder and (act == 'show' or act == "update") then
      out.finder = view.finder -- show help message
    end
  end

  local smod = rec and params.smod
  local frm = smod and self.util.rels(self,self.model,view and view.list,smod) or {}
  if act == "show" and smod then -- on submode sort or arrow
    --for k,v in pairs(frm.link) do debug.log(k,'=FRM=',v) end
    out.frm = concat{"<subfrm id='",smod,"'>",concat(dbg,"<br/>"),self:bind("list"):run(smod,frm,rec),"</subfrm>"}
  --elseif self.list and (not act or act=="find" or ((params.refrm or params.refsel)
  --  and act ~= "new") or (act == "update" and params.refrm and params.fn)) then
  elseif self.def.list and (not act or act=="find" or ((params.refrm or params.refsel)
    and act ~= "new") or (act == "update" and params.refrm and params.fn)) then
    local list = self.def.list.card and not cli and self:bind('card') or self:bind("list")
    if cli then list.model = self.model end -- for edit ref
    out.frm,out.acts = list:run() -- acts/nav
    --out.frm,out.acts = list() -- acts/nav
  elseif act=="show" or act=="update" or act=="delno" or (cli and act == "new") then
    if act == "update" and view.onsave then return view.onsave end
    out.frm,out.acts,out.btns = self:bind("view"):run(rec)
  elseif act=="new" or act=="edit" then
    out.frm,out.btns = self:bind("edit"):run(rec,act)
  elseif act =="delete" then
    self.conn:exec("begin")
    local ok,msg = self:del(rec)
    if ok then
      self.conn:exec("commit")
      out.frm = not cli and self:bind("list"):run()
      --out.finder = self.list and db:bind("list"):finder() or '' --todo to save finder parameters
    elseif msg then
      out = {msg} -- alert mes
    end
  elseif act == "massdel" then
    if type(params.lookpos) ~= "table" then
      self.conn:exec("begin")
      local ok,msg = self:del(params.lookpos,smod)
      if ok then 
        self.conn:exec("commit")
      elseif msg then
        out = {msg}
      end
    else
      self.conn:exec("begin")
      local ok,msg = true,nil
      for k,rec in ipairs(params.lookpos) do
        if (tonumber(rec) or 0) > 0 then
          ok,msg = self:del(rec,smod)
          if not ok then out = {msg} break end
        end
      end
      if ok then
        self.conn:exec("commit")
      elseif msg then
        out = {msg}
      end
    end
    if not out[1] then -- not error
      if smod and frm then
        params.act = "show"
        out.frm = concat{"<subfrm id='",smod,"'>",
          self:bind("list"):run(smod,frm,rec),"</subfrm>"}
      else
        out.frm = self:bind("list"):run()
      end
    end
  elseif act == "suggest" then
    out.suggest = self:suggest()
  elseif act == "prev" or act == "next" then
    local recno = params.frecno
    if recno then
      local qry = concat{'select min(rowid) from ',self.model,' where rowid > ',recno}
      if act == 'prev' then
        qry = concat{'select max(rowid) from ',self.model,' where rowid < ',recno}
      end
      for rowid in self.conn:urows(qry) do
        recno = rowid
      end
      out.frm,out.acts = self:bind("view"):run(recno)
    else
      local list = self.def.list.card and self:bind("card") or self:bind("list")
      if cli then list.model = self.model end -- for edit ref
      params.shift = 25
      if act == 'prev' then
        params.shift = -params.shift
      end
      out.frm = list:run()
    end
  elseif act == 'download' and params.datafld and params.namefld then
    return self:download()
  end

  if cli then
    return out.frm and (type(out.frm) == 'string' and not out.frm:match('Ok') and out.frm) or
                                              out[1] or (#mes > 0 and concat(mes,'\n')) or nil
  end

  if (not out.frm or out.frm == '') and type(self.def[act]) == 'function' and act ~= 'suggest' then --todo
    self.def[act](self)
    params.act = 'show'
    out = self:run()
  end

  if #mes > 0 then out.alert = concat(mes,'<br/>') end
  out.title = lang[self.Name] or self.Name or name
  return out -- if {error} then alert

end

function db:download()
    local recno = params.recno
    local dispos="attachment;filename=\""
    local mime = "application/x-unknown"
    local fname = recno
    local file = nil
--
    local namefld = params.namefld
    local datafld = params.datafld
    local mod = (params.mod or ''):gsub(' ','') --todo
    local qry = concat{'select rowid,"',namefld,'","',datafld,'" from ',mod,' where rowid = "',recno,'"'}
    for row in self.conn:nrows(qry) do
      if row[namefld] then fname = row[namefld] end
      file = row[datafld]
    end
--
    if file then
      dispos = concat{dispos,fname,"\""}
      header("Content-Disposition",dispos)
      header("Content-Type",mime)
      return {file}
    end

end

function db:getcookie(key)
  local fd = io.open(concat{self.conf.db,".cli"},"r")
  if not fd then return end
  local line = fd:read("*L")
  local k,v = line:match("(%w+)=(%w+)")
  if k == key then return v end
end

function db:get(mid,conf) --app.mod, env from access
  local app,path = conf and conf[1] ,conf and conf[3]
  if (mid or ''):find('%.') then app,mid = mid:match("(.*)%.(.*)") end
  if not app or app == '' then return end

  local modname = concat{path,".",app,".mods.",mid}
  package.loaded[modname] = nil --todo force load
  local mod = require(modname) --class

  local mtype = type(mod)
  if mtype == 'table' then
  elseif mtype == 'boolean' then return
  elseif mtype == 'string' then return mod
  elseif mtype == 'function' then return mod()
  end

  local lng,apps,site = self.conf.lang,self.conf.apps,self.conf.site

  pcall(require,concat{"yoke.site.apps.page.lang.",lng})
  if path == 'site.apps' and lng and lng ~= 'en' then
    for _,row in ipairs(site or {}) do
      if row[2] then pcall(require,concat{"yoke.site.apps.",row[1],".lang.",lng}) end
    end
  elseif path == 'apps' and lng then
    local name = concat{"apps.",app,".lang.",lng}
    package.loaded[name] = nil --force load
    pcall(require,name)
    pcall(require,concat{"apps.",app,".meta.lang.",lng})
  end

  mod.app = app
  self.app = app --path ~= 'site.apps' and app or nil
--
  for k,v in ipairs(apps[mod.app] or {}) do
    if v[1] == mid then
      if not apps[mod.app][k][3] then apps[mod.app][k][3] = {} end
      for kk,vv in pairs(conf.rels) do
        apps[mod.app][k][3][kk]=vv -- {mod='app'}
      end
      break
    end 
  end
--
  self.model = mid -- site
  if path ~= 'site.apps' then --self.app then
    self.model = concat{self.app,'.',mid}
  end

  if not self.defs[self.model] then
    self.defs[self.model] = db:subclass(self.model):include(mod)
    if conf.extend then
      self.util.extend(self.defs[self.model],mod,conf.extend)
    end
  end
  self.def = self.defs[self.model]
  if not self.def.mod then    --
    self.def.mod = self.model --if def.mod ~= model then self.model is sub model
  end
  --self.util.apps(self) --todo view,list clean on apps
  --for k,v in pairs(self.subclasses) do debug.log('subclass:',k.name) end
  --for k,v in pairs(self.__instanceDict) do debug.log(k,'==',v) end
  debug.log('MODEL',self.model)
  return self:run()
end

function db:access(mod,recno,user,act,app)
  --debug.log('ACCESS MOD,RECNO,USER',mod,recno,user) --todo refact
  local model = mod
  if (mod or ''):find('%.') then --todo --if type(mod) ~= 'string' then return end
    app,mod = mod:match('(.*)%.(.*)')
  end
  if not self.user.id then
    local key = nil
    if not self.conf.cli then
      key = self:getcookie('yokeid')
    end
    if not key then
      key = cookie("yokeid")
    end
    if key and #key == 50 then
      for row in self.conn:nrows(concat{[[select login,admin,roles.pages,menu,
        users.rowid as rid,home,ifnull(lang,'') as lang]],
        self.conf.apps.firm and ",person" or ' ',[[
        from users left join roles on users.role = roles.rowid
        where cookie=']],key,"' limit 1"}) do
             self.user:init(row)

      end
    end
  elseif not self.user.person then
      for row in self.conn:nrows(concat{[[select login,admin,roles.pages,menu,
        users.rowid as rid,home,ifnull(lang,'') as lang]],
        self.conf.apps.firm and ",person" or ' ',[[
        from users left join roles on users.role = roles.rowid
        where users.rowid=']],self.user.id,"' limit 1"}) do
              self.user:init(row)
      end
  end
--
  if not mod or type(mod) ~= 'string' then return end

  local guest = self.user.guest
  if guest and not self.user.id and act then
    if guest[act] then return true end
    return --todo
  elseif act == 'new' and self.def.view.view then
    return
  elseif recno or user then
    if not user and not guest then
      local qry = concat{"select * from ",app or 'main',".",mod," where rowid = ",recno}
      for row in self.conn:nrows(qry) do user = row.user end
    end
    if user and not self.user.admin then
      local acts = {new='c',view='r',list='r',edit='w',update='w',delete='d',assign='a'}
      local role = string.match(self.user.pages or "",concat{mod,":(%a*)"})
      local roles = string.match(self.user.pages or "",concat{app or self.app or "",":(%a*)"})
--^
      if role and act then --todo role or roles order
        if act == "list" then if role == 'c' then return false end return true end
        local own = (string.find(role,'c') and (tonumber(user) == self.user.id)) or nil
        if own and act ~= 'assign' then return true end
        if string.find(role,acts[act]) then
          if (act == 'view') and (role == 'r') then
            return false
          end
          return true
        end
        return false
      end

      if roles and act then
        if act == "list" then if roles == 'c' then return false end return true end
        local own = (string.find(roles,'c') and (tonumber(user) == self.user.id)) or nil
        if own and act ~= 'assign' then 
          return true
        end
        if string.find(roles,acts[act]) then
          if (act == 'view') and roles == 'r' then
            if not role or role == 'r' then
              return false
            end
          end
          if role and not string.find(role,acts[act]) then return false end
          return true
        end
        return false
      end
--$
--
    end
    if mod == 'users' and recno and recno == self.user.id then return true end -- metas
    if not self.user.admin and not user and recno and not guest then return end
    return true
  end
  local cli = self.conf.cli
--
  local modname = nil
  local qry = concat{"select id,name,access,ifnull(menu,0) as menu,content ",
      "from pages where id = '",mod,"' and ifnull(active,0)+0 = 1 and ifnull(content,'') <> '' limit 1"}
  local stmt = self.conn:prepare(qry)
  if not stmt then return self.conn:errmsg() end
  for row in stmt:nrows() do
    if (self.user.admin or tonumber(row.access) == 3 or
       (self.user.id and not string.match(self.user.pages or "",mod..":0"))) then
      stmt:finalize()
      return not cli and {title=lang[row.name] or row.name,
                          frm = concat{'<div id="',row.id,'" class="section">',row.content,'</div>'},finder = ''}
             or row.content
    end
    modname = row.name
  end
  stmt:finalize()

  local extend,rels,result = nil,{},nil

  for a,app in ipairs(self.conf.apps or {}) do
    local conf = self.conf.apps[app[1]] or {} --todo class db to self
--
    for mid,ext in pairs(conf.extend or {}) do --todo multi ext
      if mid == mod or mid == model then
        extend = ext
      end
    end
--
    for i,row in ipairs(conf or {}) do
      local id,name = row[1],row[2]
      if row[mod] then
        local idx,link = row[mod],nil
        if type(idx) == 'table' then idx,link = row[mod][1],row[mod] end
        idx = idx == 1 and a*10+i or idx
        rels[row[1]] = {app[1],idx,link}
      end

      if id == mod then
        if self.user.admin or (self.user.id and not
            string.match(self.user.pages or "",mod..":0")) or row.guest then
          --db.conf.apps[app[1]] = conf --todo
          db.Name = name
          db.App = app[1]
          result = {app[1],name,"apps"}
          if not self.user.id and row.guest then
            self.user.guest = type(row.guest) == 'table' and row.guest or {}
          end
        else
          modname = name
          break
        end
      end
    end--ipairs conf
    if modname then break end
  end
--
  if not modname then
    for a,app in ipairs(self.conf.site or {}) do
      local conf = app[2] and require(concat{'yoke.site.apps.',app[1],'.conf'}) or {}
      self.conf.site[app[1]] = conf --
      for _,row in ipairs(conf or {}) do
        local id,name = row[1],row[2]
        if id == mod then
          if self.user.admin or (self.user.id and (row.off or (row.access == 'view' and params.act == 'show')))
                             or (id == 'metas' and (params.act == 'new' or params.act == 'update')
                                             and self.conf.signup) or mod == 'login'
          then
            db.conf.apps[app[1]] = conf
            db.Name = name
            result = {app[1],name,"site.apps"}
          else
            modname = name
          end
          break
        end
      end
    end
  end
--
  if result then
      result.rels = rels
      result.extend = extend
      return result
  end

  return concat{lang.noreg or "No access for ",lang[modname] or modname or mod}

end

function db:onepage()
  if not params.onepage then return end
  local resp = ""
  for page in string.gmatch(params.onepage,"%a+") do
    page = db:page(page,true)
    resp = concat{resp,"",(type(page) == 'table' and type(page.frm) == 'string' and page.frm) or
                          (type(page) == "string" and page or "")}
  end
  return concat{"<aresp><frm>",resp,"</frm></aresp>"}
end

function db:page(mod,sub)
  local xml = [[<aresp>
    <title>$title</title>
    <header>$header</header>
    <acts>$acts</acts>
    $door
    $menu
    $finder
    $jsed
    $nav
    <btns>$btns</btns>
    <frm>$frm</frm>
    <alert>$alert</alert>
  </aresp>]]
  if not mod then
    local logo = concat{db[1] or '',":",os.date("%a %X")}
    local finder = sub and sub.finder and concat{'<fnd>',sub.finder or '','</fnd>'} or ''
    return not self.conf.cli and self.util:sub(xml,
      {menu=sub and sub.menu and concat{"<menu>",sub.menu or '',"</menu>"} or '',
      acts='',alert='',finder=finder,title='&#160;',jsed='',
      frm=sub and sub.frm or concat{"<center><h1>",logo,"</h1></center>"},
      door=sub and sub.door and concat{"<door>",sub.door or '',"</door>"}  or '',
      })
      or logo
  end
  if type(mod) == 'table' then
    debug.log('BASE/PAGE/MOD',mod)
    mod = mod[1]
  end --todo
  local out = self:access(mod)

  if type(out) == 'string' then
    return out
  elseif type(out) ~= 'table' or not out.frm then
    out = db:get(mod,out)
  end

  if type(sub) == 'boolean' then return out end -- no xml

  if not out or out == true then return end
  local js = self.conf.js
  if type(out) == 'string' then
    out = {frm = out,finder=''}
  elseif out.suggest then return out.suggest
  elseif type(out[1]) == 'string' then return out[1]
  elseif type(out[1]) == 'table' then -- select options
    local options = {}
    for k,v in ipairs(out) do
      tins(options,"<option></option>")
      for kk,vv in ipairs(v) do
        tins(options,concat{"<option ",vv[3] and "selected='selected'" or "",
              "value='",vv[1],"'>",vv[2] or vv[1],"</option>"})
      end
      if k ~= #out then tins(options,"^") end
    end
    return concat(options)
  elseif out.jsed then
    out.jsed = concat{'<jsed>',out.jsed,'</jsed>'}
  elseif not out.frm or out.frm == '' then
    return concat{mod or '','?',tostring(params.act) or ''}
  elseif params.report then
    out.jsed = concat{"<jsed>",out.frm,"</jsed>"}
    out.frm = nil
  end
  out.door = sub and sub.door and concat{"<door>",sub.door or '',"</door>"}  or ''
  out.menu = sub and sub.menu and concat{'<menu>',sub.menu or '','</menu>'} or ''
  out.finder = out.finder and concat{'<fnd>',out.finder or '','</fnd>'}  or ''
  out.btns = out.btns or ''
  out.frm = out.frm or ''
  out.acts = out.acts or ''
  out.alert = out.alert or ''
  out.title = out.title or '&#160;'
  out.jsed = out.jsed  or ''
  out.nav = out.nav and concat{"<nav>",out.nav,"</nav>"} or ''
--todo
--  if mod == 'login' then 
--    out.nav = '<nav></nav>' -- clear left nav
--  end
  local userface = self.user.menu.top -- and not self.user.admin
  if self.user.id and not userface then
    out.header = out.title
  else
    out.header = ''
  end
  if (out.title or ''):match('>([%s%a%d%._-]+)<') then --skip html tags
    out.title = out.title:match('>([%s%a%d%._-]+)<')
  end

  return self.util:sub(xml,out)

end

function db:suggest()
  local mod,q,fld,any,cond = params.mod,params.q,params.fld,params.any,params.where
  if not mod or not q or not fld then return end
  local resp,flds = {},{}
  q = q:gsub("'","''")
  local info = {}
  local app = self.app
  if mod:match('%.') then
    app,mod = mod:match('([^%.]+)%.([^%.]+)')
  end
  for rows in self.conn:rows(concat{'pragma ',app,'.table_info(',mod,')'}) do
    info[rows[2]] = true
  end


  for v in fld:gmatch('[^,]+') do
    if info[v] then
      flds[#flds+1] = v
    else
      flds[#flds+1] = concat{'"',v,'"'}
      info[v] = 'SHOW'
    end
  end
  local where = concat{' ulower(',flds[1],") like '",any and '' or '%',self.lib.lower(q),"%' "}
  if any then
    fld = fld:gsub(',',"||'--'||")
    for i=2,#flds do
      where = concat{where,concat{' or ulower(',flds[i],") like '",self.lib.lower(q),"%' "}}
    end
  end

  if not self:access(mod,nil,self.user.id,"list") then
    if info.user then
      where = concat{"(",where,") and user = ",self.user.id}
    end
  end

  local qry = concat{"select rowid,",concat(flds,',')," from `",mod,"` where (",where,")",
    cond and concat{" and ",cond} or ''," order by ",flds[1], " limit 15"}
  local stmt = self.conn:prepare(qry)
  assert(stmt,self.conn:errmsg())
  if stmt then
    while stmt:step() == self.dbm.ROW do
      local row = stmt:get_values()
      local nrow = stmt:get_named_values()
      for k,v in pairs(row) do
        if info[v] == 'SHOW' then
          v = self.def.field and self.def.field[v] and self.def.field[v](self,nrow) or ''
        end
        row[k] = tostring(v or ''):gsub('"',"'"):gsub("^%s+",""):gsub("%s+$","") 
      end
      resp[#resp+1] = concat{'["',concat(row,'","'),'"]'}
    end
    stmt:finalize()
  end
  return concat{'{"options":[',concat(resp,","),"]}"}
end

function db:bind(mod)
  if not db.form[mod] then
    db.form[mod] = db:subclass(concat{'yoke.form.',mod}):include(require("yoke.site.form."..mod))
  end
  return db.form[mod]
end

function db:del(recno,smod)
  if (tonumber(recno) or 0) <= 0 then return end
  local ok,msg,sdb = true,nil,nil
  local mod = smod or self.model
--
  local app
  if smod then
    local res = self:access(mod)
    local apps = self.conf.apps
    app = self.App
    if mod:find('%.') then
      app,mod = mod:match('([^%.]+)%.(.*)')
    end
    for k,v in ipairs(apps[app] or {}) do
      if v[1] == mod then
        if not apps[app][k][3] then apps[app][k][3] = {} end
        for kk,vv in pairs(res.rels) do
          apps[app][k][3][kk]=vv -- {mod='app'}
        end
        --sdb = setmetatable(require(concat{'apps.',app,".mods.",mod}),{__index=self})
        local model = mod:find('%.') and mod or concat{app,'.',mod} --todo site apps
        if not self.defs[model] then
          self.defs[model] = db:subclass(model):include(require(concat{'apps.',app,".mods.",mod}))
        end
        sdb = self.defs[model]
        mod = model
        break
      end
    end
    if sdb and sdb.delete then ok,msg = sdb:delete(recno) end
  else
    if self.def.delete then ok,msg = self.def:delete(recno) end
  end

  if not ok or not self:access(mod,recno,nil,"delete") then return false,msg end

  for _,rel in ipairs(self.util.rels(self,mod,nil,nil,recno,app)) do

    --do return false,mod..','..app..':'..rel.app..','..rel.mod end

    if rel.app and not rel.mod:match('%.') then
      rel.mod = concat{rel.app,'.',rel.mod}
    end
    local qry = concat{"select rowid from ",rel.mod," where ",rel.where}

    for rec in self.conn:urows(qry) do ok,msg = self:del(rec,rel.mod) end
    if not ok then return false,msg end
--
    qry = concat{"delete from ",rel.mod," where ",rel.where}
    ok = (self.conn:exec(qry) == 0)
    if not ok then return end
  end

  local qry = concat{"delete from ",mod," where rowid = '",recno,"'"}
  return self.conn:exec(qry) == 0
end

function db:open()
  if not io.open(self.conf.db) then
    os.execute("mkdir "..self.conf.db)
  end
  db.conn = db.dbm.open(concat{self.conf.db or "",'/.',self.conf.dbf})
  if not self.conn then return end
  db.conn:busy_timeout(20000) -- 20 sec
  db.conn:exec("PRAGMA journal_mode = WAL")
  db.conn:create_function("ulower",1,function(ctx,str)
      ctx:result_text(self.lib.lower(str or ""))
    end)
  if self.conf.trace then
    if self.conf.js and not self.conf.cli then
      local fd = io.open(concat{self.conf.data,"/.yoke.log"},"a")
      db.conn:trace( function(ud, sql) fd:write(concat{os.date("%Y-%m-%d %H:%M:%S,"),sql,"\n"}) end )
    else
      db.conn:trace( function(ud, sql) print("SQL:",sql,not self.conf.cli and "<br/>" or "") end )
    end
  end

  for k,v in ipairs(self.conf.apps) do
    db.conn:exec(concat{"attach database '",self.conf.db,'/',v[1],"' as ",v[1]})
  end

  db.conf.js = (params and not params.lynx and not self.conf.cli) --todo

  debug.log('OPEN',self)
end

function db:close()
  if db.conn then
    debug.log('CLOSE',self)
    db.conn:close()
    db.conn = nil
    db.defs = {}
  end
end

function YOKEDBCLOSE() -- for pcallk
  db:close()
end

function db:init(msg)
    debug.log('INIT START')

    msg = {msg}
    self.conn:trace(function(ud, sql) msg[#msg+1] = sql end)
    db:subclass('yoke.init'):include(require"yoke.snap.init"):run()

    debug.log('INIT FINISH')

    self.conn:trace(nil)
    debug.log(concat(msg,"\n"))
    self.initialized = true
end

function db:initialize(env)
  db.env = env or {}
  local conf = require"yoke.site.conf"
  conf = setmetatable(db.conf,{__index=conf})
  arg = arg or {};  arg.conf = conf
  db.util = require'yoke.snap.util'
  lang = {}
  local concat = table.concat

  conf = db.util.conf(conf); db.link = db.util.link
  conf.db = concat{conf.data,"/.",conf.dbf}
  conf.idx = conf.idx or (params and params.idx) or "yoke.lua"
  conf.content = concat{conf.title," :",os.date("%a %X")}

  os.setlocale(conf.locale or "")
  os.setlocale("C","numeric")
  db.conf = conf
  db.user = setmetatable(require'yoke.site.apps.user.mods.users'.user,{__index=self})
  --db.user = db:subclass('user'):include(require'yoke.site.apps.user.mods.users'.user) --todo
  db.user.menu.top = conf.userface

  local ok
  ok,db.lib = pcall(require,"yoke.lib")
  if not ok then
    db.lib = {}
    db.lib.md5 = require'md5'.sumhexa
    db.utf8 = require"lua-utf8"
    db.lib.lower = db.utf8.lower
    db.lib.len = db.utf8.len
    db.lib.sub = db.utf8.sub
  end
  db.dbm = require"lsqlite3"

  debug.log('\nNEW:',self,'sqlite',
             db.dbm.version(),'lsqlite',
             db.dbm.lversion())
  db.form = {}
  db.form.page = db:subclass('yoke.page'):include(require"yoke.site.page")
  db.form.snap = db:subclass('yoke.snap'):include(require"yoke.site.snap")
  db.form.apps = db.util.apps
  db.defs = {} -- mods
end

return db
