------------------------------
-- yoke © luamani@yahoo.com --
------------------------------

local tins,concat,format = table.insert,table.concat,string.format

local db = {}

function db:run(recno,act,subname,subform)
  if not act then return end
  local dform = subform or self.def.view
  self.util.apps(self,dform) --clean on apps

  local dname = subname or self.model
  local out = {}
  local row,cnt,nrow
  local assign
  if (tonumber(recno) or 0) > 0 then
    local qry = self.util:mkqry(recno,self.def.view.mod or dname,dform,'edit')
    local stmt = self.conn:prepare(qry)
    assert(stmt,self.conn:errmsg())
    if stmt:step() == self.dbm.ROW then
      row = stmt:get_values()
      nrow = stmt:get_named_values()
      cnt = stmt:columns()
    end
    stmt:finalize()
    if nrow and nrow.user then
      if not self:access(dname,recno,nrow.user,"edit") then
        return lang["No access write"] or "No access write"
      end
      assign = self:access(dname,recno,nrow.user,"assign")
    end
  elseif not self:access(dname,nil,self.user.id,"new") then
    return lang["No access create"] or "No access create"
  end

  local js = dform.js and concat{"<script>",type(dform.js) == 'string' and dform.js or dform.js(self.def,nrow) or '',
                         "</script>"} or ""
  local ii,tr = 2,0

  for k,v in ipairs(dform) do
    local vid = v[1]
    local nm =  not v.readonly and v.ht ~= "SHOW" and v[2] --if not v[2] then break end
    local th,value,val = "","",nil
    if nm and v.ht ~= "OBJECT" then
      if tr == 0 then tins(out,"<tr>") end
      local width=15
      local align="right"
      if dform.left then
        width=85
        align="left"
      end
      th = format("<td class='desc' valign='top' align='%s' nowrap='nowrap' width='%d%%' %s>%s%s</td>",align,width,
          v.opt or "",
          lang[nm] or nm,v[3] and concat{'&#160;<span style="color:red">',
            type(v[3])=='string' and v[3] or ':','</span>'} or '')
      val = params[vid] or params[concat{self.model,".",vid}]
    --todo
      if not val and type(self.new) == 'table' and self.new[self.model] then
        val = self.new[self.model][vid] or self.new[self.model][concat{self.model,".",vid}]
      end
    end
    --
    if nm and v.ht ~= "SHOW" and (act == "edit" or act == lang.Save or act == "Save" or
            (act=="new" and val)) then
      if val then
        value = val -- self.util:escape(val)
      elseif row and cnt and cnt > 0 and row[ii] then
        value = v.ht ~= "HTML" and self.util:escape(row[ii]) or row[ii]
      end
      ii = ii + 1
    end
    --if not nm then ii = ii + 1 end --todo

    if v.ht == "DATETIME" and nm then
      value = (value ~= '0' and value ~= '') and os.date("%Y-%m-%d %H:%M",tonumber(value)) or ''
    elseif v.ht == "DATE" and nm then
      value = (value ~= '0' and value ~= '') and os.date("%Y-%m-%d",tonumber(value)) or ''
    end

    if nm and not (v.ht == "SHOW" and dform.readonly and not v.help) then
      if (not value or value == '') and dform.defaults and dform.defaults[v[1]] then
          value = dform.defaults[v[1]]
      end
      local td = self:ht(v,value,subname,nrow,assign,recno)
      if v.ht=="OBJECT" then
        th = concat{th,'<td align="right" class="desc"><u>',nm,'</u></td><td></td>'}
      end
      if not dform.left then
          tins(out,th)
          tins(out,td)
      else -- left side values
          tins(out,td)
          tins(out,th)
      end
    end
--
    if nm and v.ht ~= "OBJECT" and not (v.ht == "SHOW" and dform.readonly and not v.help) then
      tr = tr + 1
      local columns = dform.columns or self.conf.view.cols or 1
      if tr == columns then
          tins(out,"</tr>")
          tr = 0
      end
    end
  end -- for dform

  if tr ~= 0 then tins(out,"</tr>") end
--
  if subname then return concat(out) end

  local submit,fact,hidden = "",format('action="%s?mod=%s&lynx=true"',self.conf.idx,dname),{}

  for k,v in pairs(self.def.hidden and self.def:hidden(nrow,recno) or {}) do
    tins(hidden,format("<input type='hidden' name='%s' value='%s'/>",k,v))
  end

  local items = type(dform.submit) == 'table' and dform.submit or 
            {{dname,lang.Save or "Save",{act='update',ajaxfiles = dform.file and true or nil},'submit'}}
  if #items == 0 then items = {items} end
  local links = {} --submit
  local btns = {}  --form buttons

  if dform.file and not self.conf.js then
    fact = format([[ %s enctype='multipart/form-data']],fact)
    submit = format([[<button type='submit' name='act' value="update">%s</button>]],
                            lang.Save or 'Save')
    items = dform.submit or {}
    for i,item in ipairs(items) do
      links[i] = self:link(item[1],item[2],item[3],item[4] or 'submit')
    end
    submit = concat{submit,concat(links,' ')}
  else
    for i,item in ipairs(items) do
      links[i] = self:link(item[1],item[2],item[3],item[4] or 'submit')
      btns[i] = self:link(item[1],item[2],item[3],item[4] or 'submit','edfrm')
    end
    if not self.conf.js or dform.submit == 'bottom' then -- lynx
      submit = concat(links,' ')
    end
  end

  if recno then
    tins(hidden,format("<input name='recno' type='hidden' value='%s'/>",recno))
    tins(hidden,format("<input name='fmod' type='hidden' value='%s'/>",params.fmod or dname))
  end
  if params.pmod and params.prec then
    tins(hidden,format("<input name='pmod' type='hidden' value='%s'/>",params.pmod))
    tins(hidden,format("<input name='prec' type='hidden' value='%s'/>",params.prec))
  end
  if params.refrm then
    if params.refld then
      tins(hidden,format("<input type='hidden' name='refld' value='%s'/>",params.refld))
    end
    if params.fn then
      tins(hidden,format("<input type='hidden' name='fn' value='%s'/>",params.fn))
    end
    if params.select then
      tins(hidden,format("<input type='hidden' name='select' value='%s'/>",params.select))
    end
    tins(hidden,format("<input type='hidden' name='refrm' value='%s'/>",params.refrm))
    tins(hidden,format("<input type='hidden' name='rowind' value='%s'/>",params.rowind or ""))
  end
--lines
  local links = {}
  dform.list = self.util.rels(self,dname,dform.list)
  for i,row in ipairs(dform.list or {}) do
    if row and row[2] and row[2].link and row[2].link.ls then
      dform.list[i][2] = row[2].link.ls
    end
    local name,frm = row[1],row[2]
    if frm.edit then
      table.insert(links,format("<input type='hidden' name='list' value='%s'/>",name))
      local list = self:bind("list")
      local sname = list.name
      local tab = list:run(name,frm,recno,self)
      if tab ~= "" then links[#links + 1] = tab end
      list.name = sname
      break
    end
  end
--
  local class = dform.left and "edit-form-left" or "edit-form"
  return format([[<div class="section"><section class="section-space"><div class="container">
      <div class="%s">
      <form id="edfrm" name="edfrm" method="post" %s autocomplete="off">
      %s
      <table width='100%%' class='inner' border='1' frame='void' rules='none' 
          cellpadding='1' cellspacing='1'>
      %s
      </table>
      <table class='inner' width='100%%' cellspacing='1'><tr><td align='center'>%s
      &#160;<button type='reset'>%s</button></td></tr>
      </table>
      <div id="links">%s</div></form></div>
      %s
      </div></div></div>
  ]],dform.class or dname,fact,concat(hidden),concat(out),submit,lang.Cancel or "Cancel",concat(links),js),
  concat(btns,' ')
end

function db:ht(v,value,smod,nrow,assign,recno,shift)
  --if v.rt and self.conn:exec(concat{'select 1 from ',v.rt}) == 1 then return "<td></td>" end
  local id,nm = v[1],v[2]
  local required = v[3] and concat{"required='required'"} or ""
  smod = smod or ""
  local out = {}
  if v.ht == "REF" or v.ht == "SELF" then
    local sep,fld,any = "","",""
    for kk,vv in ipairs(v.rf or {}) do
      if vv.ht ~= "SHOW" then
        fld = concat{fld,sep,vv[1]}
        if (vv[1] or ''):match(',') then any = '^' end -- search and join all fields
        sep = ","
      end
    end
    if fld == "" then fld = "name" end
    local rid = nrow and nrow[(v.fd or id):gsub("^.+%.","")] or tonumber(value) or 0
    if not v.fd and (tonumber(rid) or 0) > 0 and v.rt then
      local subqry = concat{"select ",fld," from ",v.rt," where rowid = ",rid}
      local substmt = self.conn:prepare(subqry)
      if substmt then
        if substmt:step() == self.dbm.ROW then
          sep,value = "",""
          local row = substmt:get_values()
          for kk,vv in ipairs(row) do
            value = concat{value,sep,vv}
            sep = " "
          end
        end
        substmt:finalize()
      else
        tins(out,self.conn:errmsg())
      end
      if value == '' then value = v[2] end
    end

    local edfrm = "edfrm"
    if self.conf.js then
      local name = concat{smod,v.fd or id}
      local imod = (smod ~= '' and (v.self or v.ht == 'SELF') ) 
          and format("<input type='hidden' name='%s' value='%s'/>",smod,nrow.rowid or "") or ""
      tins(out,format([[<td nowrap="nowrap" valign='top'>%s
          <input %s %s name='%s' value="%s" size='%s' style="width:%sch;" onfocus="suggest(this,'%s','%s','%s'%s);" />
          <input type='hidden' value='%s' name='%sId' />
          <input type='button' value="..." onclick="%s"/></td>]],imod,v.opt or "",
          required,name, self.util:escape(value),
          v.sz or "",v.sz or "",v.rt,fld,any,
          v.where and concat{",'",v.where,"'"} or '',
          rid,name,
          self:link('popup',nil,{mod=v.rt,refrm=edfrm,refld=name,fn=fld,shift=shift and 
            "'+$(this).parent().parent().index()+'" or nil,any=(any=='^' and 1 or nil)})
      ))
    else
      tins(out,format([[<td nowrap="nowrap">
        <a href="%s?mod=%s&refsel=%s&refid=%s&refld=%s">%s</a>
        <input type='hidden' value='%s' name='%s' />
        <input type='hidden' value='%s' name='%sId' /></td>]],
        self.conf.idx,v.rt,self.model,params.recno or recno,id,value ~= "" and value or "...",
        value,smod..id,val,smod..id))
    end
    return concat(out)
  elseif v.ht == "SELECT" or v.ht == "MULTI" then
    local fnames,msel = '',''
    if v.ht == "MULTI" and v.sz > 1 then
      msel = concat{" multiple='multiple' size='",v.sz,"' "}
    end
    if v.opt then msel = concat{msel," ",v.opt} end
    local imod = (smod ~= '' and v.self) and format("<input type='hidden' name='%s' value='%s'/>",
                    smod,nrow.rowid or "") or ""
    local width = v.sz and format("style='width:%dpx;'",v.sz) or ''
    local sel = {format([[<td align='left' valign='top' style='display:flex;'>%s
        <select %s name='%s' %s %s id='%s' %s><option></option>]],imod,
        required,smod..id,msel,(id == 'user' and not assign) and 'disabled="disabled"' or "",
        id,width)}

    if not v.rt then
      if v.ht == "SELECT" then
        if type(value) == "table" and #value > 0 then
          value = value[1]
        end
        for kk,vv in ipairs(type(v.rf)=="table" and v.rf or self.conf[v.rf] or {}) do
          tins(sel,concat{"<option value='",vv[1],"'",
            tostring(value) == tostring(vv[1]) and " selected='selected' " or "",">",
            lang[vv[2]] or vv[2] or vv[1],"</option>"})
        end
      elseif v.rf then
        value = concat{value,","}
        for kk,vv in ipairs(v.rf) do
          local p = string.find(value,vv[1])
          tins(sel,concat{"<option value='",vv[1],"'",
            p and value:sub(p+string.len(vv[1]),p+string.len(vv[1])) == "," and
              " selected='selected' " or "",">",vv[2] or "","</option>"})
        end
      end
    else -- v.rt
      if not v.rf then v.rf = {{"name","Name"}} end
      if v.rf[1].ht == "SHOW" then -- build select in show
        for kk,vv in ipairs(v.rf) do
          if kk > 2 then fnames = concat{fnames,","} end
          if kk > 1 then fnames = concat{fnames,vv[1]} end
        end
        if self.def.field and self.def.field[v.rf[1][1]] then
          for k,v in ipairs(self.def.field[v.rf[1][1]](self,nrow) or {}) do
            tins(sel,concat{"<option ",v[3] and "selected='selected'" or "",
              "value='",v[1] or '',"'>",v[2] or v[1] or '?',"</option>"})
          end
        end
      else
        local subqry = {"select "}
        if act == "new" and tonumber(value) then
          tins(sel,concat{"<option selected='selected' value='",(value or ""),"'>"})
          local f0,sep = {""},""
          for kk,vv in ipairs(v.rf) do
            if vv.ht ~= "SHOW" then
              tins(subqry,concat{sep,vv[1]})
              sep = ","
            end
          end
          tins(subqry,concat{" from ",v.rt," where rowid = ",value," order by "})
          local fi = 1
          if v.rf[1].ht == "SHOW" then fi = 2 end
          tins(subqry,v.rf[fi][1])
          local substmt = self.conn:prepare(concat(subqry))
          if substmt then 
            if substmt:step() == self.dbm.ROW then
              local row = substmt:get_values()
              sep = ""
              for kk,vv in ipairs(row) do tins(f0,sep..vv); sep = " " end
            end
            substmt:finalize()
          else
            tins(out,self.conn:errmsg())
          end
          tins(sel,concat(f0)) -- escape(sel,f0);
          tins(sel,"</option>")
        else -- edit
          tins(subqry," rowid,")
          sep = ""
          for kk,vv in ipairs(v.rf) do
            if vv.ht ~= "SHOW" then
              local fld = vv[1]
              if vv[1]:match(',') then fld = vv[1]:gsub(',',"||'-'||") end
              fnames = concat{fnames,sep,vv[1]}
              tins(subqry,concat{sep,fld})
              sep = ","
            end
          end
          tins(subqry,concat{" from ",v.rt,v.where and (" where "..v.where) or "",
              " order by "})
          local fi = 1
          if v.rf[1].ht == "SHOW" then fi = 2 end
          tins(subqry,v.rf[fi][1])
          subqry = concat(subqry)
          local substmt = self.conn:prepare(subqry)
          if not substmt then
            tins(out,concat{subqry,':',self.conn:errmsg()})
          else
            for row in substmt:rows() do
              local optname = row[2] or 'noname'
              if v.ht == "SELECT" then
                tins(sel,concat{"<option ",row[3] and concat{"data='",row[3],"'"} or ''," value='",row[1],"' "})
                if tonumber(value) == row[1] then tins(sel," selected='selected' ") end
              else -- MULTI
                tins(sel,concat{"<option value='",row[2],"' "})
                if value:find(row[2]) then tins(sel," selected='selected' ") end
                if lang[optname] then optname = lang[optname] end
              end
              tins(sel,concat{">",optname or "","</option>"})
            end
            substmt:finalize()
          end
        end --not show
      end --v.rt
    end
    tins(sel,"</select>")
    tins(out,concat(sel))
    if v.rf and v.rt and v.rt ~= "" and self.conf.js and v.rf[1].ht ~= "SHOW_off" then
      tins(out,format([[&#160;<input type='button' value="..." onclick="%s"/>]],
      self:link('popup',nil,{mod=v.rt,refrm='edfrm',refld=smod..v[1],fn=fnames,select=1})))
    end
    tins(out,"</td>")
    return concat(out)
  elseif v.ht == "CHECKBOX" then
    if type(value) == 'table' then value = nrow[v.id or id] end
    if not v.slider then
        return concat{"<td align='left' valign='top'><input type='checkbox' name='",smod..(v.id or id),"'",
          (tonumber(value) or 0) > 0 and " checked='checked'" or '',v.opt or "",
          " value='",v.id and id or 1,"'/></td>"}
    else 
        return concat{"<td align='left' valign='top'><label class='switch'><input type='checkbox' name='",smod..(v.id or id),"'",
          (tonumber(value) or 0) > 0 and " checked='checked'" or '',v.opt or "",
          " value='",v.id and id or 1,"'/><span class='slider round'/></label></td>"}
    end
  elseif v.ht == "FILE" then
    if v.label then
        return concat{"<td align='left' valign='top'>",
            "<label class='file-upload'>",
            "<span>",lang.Select or 'Select',"</span>",
            "<input ",required," id='",id,"' ",v.opt or "",
            " name='",id,"' type='file'/>",
            "</label>",
            "</td>"}
    elseif v.img then
        return concat{"<td align='left' valign='top'>",
            "<input ",required," id='",id,"' ",v.opt or "",
            " name='",id,"' type='file' onchange='imgcpy(event,\"",id,"\")'/>",
            "<img id='",id,"-img' style='max-width:250px;max-height:250px;' />",
            "</td>"}
    elseif v.camera then
        local link = self:link('popup',nil,{mod=mod,act='cam',refld=id,
                    refrm=v.bg})
        return concat{"<td align='left' valign='top'>",
            "<input ",required," id='",id,"' ",v.opt or "",
            ' name="',id,'" type="file" onclick="',link,';return false;"/>',
            "</td>",
          }
--[[
        return concat{"<td align='left' valign='top'>",
            "<input ",required," id='",id,"' ",v.opt or "",
            " name='",id,"' type='file' onclick='camCapt(this,\"",id,"\");return false;'/>",
            "<video id='",id,"-video' style='max-width:250px;max-height:250px;' autoplay class='bg-camera'></video>",
            "<img id='",id,"-img' style='max-width:250px;max-height:250px;position:relative;left:-250px;' />",
            '<img src="',v.bg or '','" id="bg-camera" alt=""/>',
            "<button id='",id,"-btn'>Photo</button>",
            "</td>",
          }
--]]

    else
        return concat{"<td align='left' valign='top'>",
            "<input ",required," id='",id,"' ",v.opt or "",
            " name='",id,"' type='file'/>",
            "</td>"}
    end
  elseif v.ht == "TEXTAREA" or (v.ht == "HTML" and not self.conf.js) then
    return format([[<td class='line1' align='left'>
      <textarea id='%s' %s name='%s' rows='%s' cols='%s'>%s</textarea></td>]],
          smod..id,required,smod..id,math.abs(v.rows or 2),math.abs(v.sz or 25),value == "" and "\r" or value)
  elseif v.ht == "PAGE" and self.conf.js then
    return format([[<td class='line1' align='left'>
      <script>
              var elpg = document.getElementById('%sPage');
              var edpg = new Jodit(elpg,{iframe:true,
                    enableDragAndDropFileToEditor:false,
              });
      </script>
      <textarea id='%sPage' %s name='%s' rows='%d' cols='25'>%s</textarea></td>]],smod..id,
          smod..id,required,smod..id,math.abs(v.sz or 2),value == "" and "\r" or value)
  elseif v.ht == "HTML" then
    local jsed = require('yoke.site.apps.page.mods.forms'):jsed(id,value)
    jsed = string.gsub(jsed,"%$([%d%w]+)",{save="", print="",form="",pdf=""})
    return concat{"<td><div style='width:500px;'>",jsed,"</div>",
                  "<input type='hidden' name='",id,"' id='",id,"'/></td>"}
  elseif v.ht == "SHOW" then
    local val = self.def.field and self.def.field[id] and self.def.field[id](self,nrow) or ''

    if v.help then
        return format("<td align='left' valign='top'>%s</td>",type(v.help) == 'string' and v.help or val)
    end

    if type(val)=='string' and val:match(">.*<") then val = val:match(">(.*)<") end
    return format("<td align='left' valign='top'><input disabled='' name='%s' value='%s' size='%d'/></td>",
        (smod or "")..id,val,v.sz or 0)
  elseif v.ht == "SQL" then
    return format("<td align='%s'>%s</td>",smod=='' and 'left' or 'right',value)
  elseif v.ht == "PW" then
    return format([[<td align='left' valign='top'><input type='password'
          value='%s' name='%s' size='%d'/></td>]],value,id,math.abs(v.sz))
  elseif v.ht == "OBJECT" then
    tins(out,format("<input type='hidden' name='%s_recno' value='%s'/>",v.rt,value))--todo
    tins(out,format("<input type='hidden' name='link_recno' value='%s'/>",recno))   --todo
    --tins(out,format("<input type='hidden' name='%sname' value='%s'/>",v.rt,v[2]))   --todo
    tins(out,self:run(value,"edit",v.rt,v.rf))
    return concat(out)
  elseif v.ht == "LIST" then
    local first = false
    local adds = {}
    local suggest,st,fd = "",type(v.st),'name'
    if st == "string" then
      suggest = format([[onfocus="suggest(this,'%s','name');"]],v.st) 
      st = v.st
    elseif st == "table" then
      suggest = format([[onfocus="suggest(this,'%s','%s');"]],v.st[1],v.st[2])
      st,fd = v.st[1],v.st[2]
    end
    for val in string.gmatch(value,"[^;]+") do
      if not first then
        first = val
      else
        adds[#adds+1] = format([[<div>
            <div style="display:inline;float:left;padding-top:3px;">
              <input size="%s" name="%s" value="%s" id="%s" %s/>
            </div>
            <div style='display:block;float:left;padding-left:8px;'>
              <a href='#' onclick='($(this).parent().parent()).remove();'>
                <div style='border:1px solid;background:white;height:2px;padding:3px 2px 3px 2px ;margin-top:4px;border-radius:2px'>
                  <div style='height:2px;width:4px;background:red'></div>
                </div>
              </a>
            </div>
          </div>]],v.sz,id,val,id,suggest)
      end
    end
    return format([[<td align='left' valign='top'><div>
      <input %s name='%s' value='%s' size='%s' id='%s' %s/>&#160;
      <img style='cursor:pointer' src="site/face/img/plus.png" 
          onclick="insrow('%s',%s,'%s','%s');" alt="+"></img>
      </div><div id="%ss" style="display:block;float:left;">%s</div>
      </td>]],required,id,first or "",v.sz,id,suggest,id,v.sz or 25,st or "",fd,id,concat(adds))
  elseif v.ht == "MATRIX" then
    tins(out,concat{[[<td align='left' valign='top'><table class='inner' border='1'
        frame='void' rules='none' cellpadding='1' cellspacing='1'>
      <tr><th>]],lang.Name or "Name","</th>"})

    for k,v in ipairs(v.rx) do tins(out,concat{"<th>",lang[v[2]] or v[2],"</th>"}) end
    tins(out,"</tr>")
    if v.ry.rt then
      local qry = concat{"select ",v.ry.rf[1][1],",",v.ry.rf[1][2]," from ",v.ry.rt,
        v.ry.wh and concat{" where ",v.ry.wh} or ""}
      v.ry.rf = {}
      for id,name in self.conn:urows(qry) do v.ry.rf[#v.ry.rf+1] = {id,name} end
    end

    for _,row in ipairs(v.ry.rf or {}) do
      local i,name,grp = row[1],row[2],row[3]
      local class = grp and 'line2' or 'line1'
      tins(out,concat{"<tr class='",class,"'><td><input type='hidden' name='",
          id,"' value='",i,"'/>",grp and '<b>' or '',
                          lang[name] or name,grp and '</b>' or '',"</td>"})
      local y,x = string.match(tostring(value),"("..i.."):(%a*)")
      local empty = (not value or value == '' or not y)
      for _,vv in ipairs(v.rx) do
        local checked = (empty or (x and string.find(x,vv[1]))) and "checked='checked'" or ""
        if v.xy == 0 then checked = '' end
        tins(out,concat{"<td align='middle'><input type='checkbox' ",checked," name='",
            concat{i,"-",vv[1]},"'/></td>"})
      end
      tins(out,"</tr>")
    end

    tins(out,"</table></td>")
    return concat(out)
  else -- text
    local opt,suggest,st = v.opt or "","",type(v.st)
    if st == "string" then
      suggest = format([[onfocus="suggest(this,'%s','name');"]],v.st) 
    elseif st == "table" then
      suggest = format([[onfocus="suggest(this,'%s','%s');"]],v.st[1],v.st[2])
    end
    local align,dir = "left",""
    if v.ht == "TOTAL" then
      align,dir = "right",""
    end
    --default
    tins(out,format([[<td align='%s' valign='top'><input %s %s
      value='%s' name='%s' id='%s' size='%s' %s %s dir='%s' style="width:%sch"/>]],align,
      required,v.ht and concat{'type="',string.lower(v.ht),'"'} or '',value,smod..id,smod..id,
      math.abs(v.sz or 25),opt,suggest,dir,math.abs(v.sz or 25)))
    if self.conf.js then
      if v.ht == "DATE" or v.ht == "DATETIME" then
        local time,fmt = false,'yyyy-mm-dd'
        if v.ht == "DATETIME" then time,fmt=true,fmt..' hh:ii' end
        tins(out,format([[&#160;<input type='button' id='b%s' value="..."
              onFocus="$(this).fdatepicker({
                format:'%s',
                language:'%s',
                weekStart:1,
                pickTime:%s,
                todayBtn:true,
                appendTo:'#frm',
                autoShow:false,
              });"/>]],smod..id,fmt,self.conf.lang or 'en',time))
      elseif v.ht == "GEO" or v.ht == "MAP" then
        tins(out,format([[&#160;<input type='button' value="..." onclick="%s"/>]],
          self:link('popup',nil,{mod=self.model,act='map',fld=id})))
      elseif v.ht == 'NUMBER' and v.slider then
        tins(out,format([[&#160;<input type='range' style="width:%spx;" %s oninput="%s"/>]],v.slider,
                  v.opt,'this.previousElementSibling.value = this.value;console.log(this.value)'))
      end
    end
    tins(out,"</td>")
    return concat(out)
  end
end

return db
