------------------------------
-- yoke © luamani@yahoo.com --
------------------------------

local concat,insert,format = table.concat,table.insert,string.format
local db = {}

function db:run()
  local mod = params.mod
  if not params.uname and not self.conf.autologin then
    if mod == "login" then
      if not self.conf.cli then
        cookie('yokeid',{value = "",expires = 1})
        self.super.user.id = nil
        if params.act == 'exit' and self.conf.idx == '' then
          header("Location",'.')
        end
      end
    end
    return self:start(mod)
  elseif params.signup or (params.mod == 'login' and params.act == 'new') then
    return self:page('login')
  elseif params.act == "password" then -- send password
    return self.conf.js and self:login() or self:start()
  elseif params.pw or self.conf.autologin then --pw can be empty
    if self.user:enter() == 'ok' then
      if self.conf.js and not self.conf.autologin then --todo
        local menu = self:enter() or {}
        params.act = 'find'
        return self:page(menu[2] and menu[2][1],{menu=menu[1],door=menu[3],nav=menu[4]})
      else
        return self:start()
      end
    else
      return self.conf.js and self:login() or self:start()
    end
  else
    return lang["Password is required"] or "Password is required"
  end
end

function db:apps(items,guest)
  local apps,idx,cli,js,home = self.conf.apps,self.conf.idx,self.conf.cli,
    self.conf.js,self.conf.home
  local item,off = guest,{}
  local onepage = self.conf.onepage
  if not self.user.admin or (self.user.pages or "") ~= "" then
    for pg in string.gmatch(self.user.pages or "","([%w%.]+):0") do off[pg] = true end
  end
  for i,app in ipairs(apps) do
    local cnt
    if not off[app[1]] then
      local conf = apps[app[1]] -- require(concat{"apps.",app[1],".conf"}) or {} --todo
      for _,mod in ipairs(conf) do
        local id,name = mod[1],mod[2]
        id = concat{app[1],'.',id} --todo base
        if not mod.off and ((not off[id] and not guest) or (guest and mod.guest and mod.guest.list)) then
          local link = self:href(id,lang[name] or name,guest,onepage)
          item = {id,name,link,mod.menu or 0,onepage}
          if id == home and not items.start then
            items.start = item
          elseif not items.start or items.start[1] ~= id then
            --insert(items,cli and item or link)
            insert(items,item)
            item.link = link
            cnt = true
          end
        end
      end
      local userface = self.user.menu.top -- and not self.user.admin
      if cnt and not guest and not cli and not userface then
          insert(items,{0,'',"<hr noshade='noshade' size='1'/>"})
      end
    end
  end

  if not items.start and item and item[1] then
    for i,row in ipairs(items) do
      if row[3] == item.link or row[1] == item[1] then
        table.remove(items,i)
      end
    end
    items.start = item
  end
end

function db:start(mod)
  local cli = self.conf.cli
  local item,items = {},{}
  local home = self.conf.home
  local content = self.conf.content
  local menu,door,finder,title,acts,nav,btns = nil,nil,'',nil,'','',''

  local login = self:link('login',"Login",nil,'nodeco')

  local exit = os.date('%X')
  local onepage = self.conf.onepage
  if mod ~= 'login' then
    self:access() --todo
  end

  local guest = not self.user or not self.user.id
  if guest then
    local qry = "select id,name,menu,ifnull(page,0)+0 from pages where active=1 and access=3 and menu+0 > 0 order by menu"
    for id,name,menu,page in self.conn:urows(qry) do
      local one = page == 0 and onepage or false
      item = {id,name,self:href(id,lang[name] or name,guest,one),menu,one}
      if id == home and not items.start and not (cli and not mod) then items.start = item
      else
         --insert(items,cli and item or self:href(id,lang[name] or name,guest))
         insert(items,item)
      end
    end
    self:apps(items,item)
--menu
    table.sort(items,function(a,b) if a[4] < b[4] then return true else return false end end)
----
    --local userface = self.conf.userface -- and not self.user.admin
    --nav = not userface and self.util:sub(ht.nav,{menu=menu,acts=''}) or ""
----
  else
    local enter = self:enter() or {}
    menu,items.start,door,nav = enter[1],enter[2],enter[3],enter[4]
  end

  if (not mod or params.act == 'exit') and items.start
                                       and not (self.term and self.term.menu and self.term.menu[1]) then
    mod = items.start[1]
  end

  if mod == "login" then
    content = cli and "cli:login" or self:login()
  elseif mod then --start or exit
    if params.act == 'exit' then params = {} end --todo yard
    content = self:page(mod,true) -- no xml = true
    if type(content) == 'table' then
      finder = content.finder or ''
      title = content.title or ''
      acts = content.acts or ''
      btns = content.btns or ''
      if finder and btns then
        finder = self.util:sub(finder,{btns=btns})
      end
      content = content.frm or ''
      --todo
      if self.conf.onepage and params.act ~= 'download' then
        for k,v in ipairs(items) do
          if tostring(v[2]) ~= '' and v[5] then -- name and onepage
            local page = self:page(v[1],true) --true - no xml
            content = concat{content,"<br/></br>",type(page) == 'table' and page.frm or page}
          end
        end
      end
      --todo end
    end

  elseif not menu then
    content = cli and "cli:login" or self:login(true)
  end
  if menu then -- user
    login = self:link('metas',self.user.login or "nologin",nil,'nodeco')
    exit = db.href(self,'login',lang.Exit or 'Exit') --self:link('login',lang.Exit or 'Exit',nil,'nodeco')
  elseif #items > 0 or items.start then
    if items.start and items.start[1] and not cli then --todo
      local start = ''
      if guest then
        if onepage then
          --start = db.href(self,items.start[1],lang[items.start[2]] or items.start[2] or name,guest,onepage)
          start = concat{"<li><a class='nodeco' href='",self.conf.idx,"#",items.start[1],"'>",
                              lang[items.start[2]] or items.start[2],"</a></li>"}

        else
          start = self:link(items.start[1],lang[items.start[2]] or items.start[2],nil,'nodeco')
        end
        insert(items,1,{0,'',start}) --todo
      else
        start = self:link(items.start[1],lang[items.start[2]] or items.start[2],nil,'nodeco',
                   "<font color='#ffaa00'>&#9679;</font>&#160;")
        insert(items,{0,'',start})
      end
    end

    if not cli then --html menu
      for k,v in ipairs(items) do
        items[k] = v[3]
      end
    end

    if cli then
      menu = 'cli:menu'
    elseif guest then --user
      if onepage then --todo
        menu = concat(items,"<li>")
      else
        menu = concat(items,"<span style='margin-left:15px;'/>")
      end
    else
      menu = concat(items)
    end
  else
    menu = lang["No public pages, please login"] or "No public pages, please login"
    login = os.date("%j %a %d.%m.%Y")
  end


  if type(content) ~= 'string' then content = '' end
  if cli then
    self.term:main(content,menu,items)
    return
  end -- of cli

  local noscript = ""
  if not params.lynx then
    noscript = concat{"<noscript><meta http-equiv='refresh' content='0;",
           concat{self.conf.idx,"?lynx=true"},"'/></noscript>"}
  end


  local path = self.conf.path
  local lib = {}
  local face = nil
  local logo =  path.."/site/face/img/logo.png"
  for aid,app in pairs(self.conf.apps) do
    if app.face then
      if app.face.lib then
        lib[#lib + 1] = app.face.lib
      end
      if app.face.logo then
        logo = concat{"apps/",aid,"/face/img/",app.face.logo}
      end
      face = {aid,app.face[2],user = app.face.user}
    end
  end

  local css,js = {},{}
  local cssface = concat{path,"/site/face/css/yoke.css"}
  if face and type(face) == "table" and face[1] then
    local userface = self.user.menu.top  -- and not self.user.admin
    if not guest then --user
      for _,val in ipairs(face.user or {}) do --libs
          local cssfile = concat{"apps/",face[1],"/face/css/user/",val,".css"}
          if io.open(cssfile) then
            css[#css+1] = concat{"<link rel='stylesheet' href='",cssfile,"' type='text/css'/>"}
          end
          local jsfile = concat{"apps/",face[1],"/face/js/user/",val,".js"}
          if io.open(jsfile) then
            js[#js+1] = concat{"<script type='text/javascript' src='",jsfile,"'></script>"}
          end
      end
    end
    if not self.user.admin then
        for _,val in ipairs(face[2] or {}) do
          local cssfile = concat{"apps/",face[1],"/face/css/",val,".css"}
          if io.open(cssfile) then
            css[#css+1] = concat{"<link rel='stylesheet' href='",cssfile,"' type='text/css'/>"}
          end
          local jsfile = concat{"apps/",face[1],"/face/js/",val,".js"}
          if io.open(jsfile) then
            js[#js+1] = concat{"<script type='text/javascript' src='",jsfile,"'></script>"}
          end
        end
        if userface then
            local cssfile = concat{"apps/",face[1],"/face/css/user.css"}
            if io.open(cssfile) then
                css[#css+1] = concat{"<link rel='stylesheet' href='",cssfile,"' type='text/css'/>"}
            end
        end
    end
    local cssfile = concat{"apps/",face[1],"/face/css/yoke.css"}
    if io.open(cssfile) then
      cssface = cssfile
    end
  end
  --if guest then nav = self.util:sub(ht.nav,{menu=menu,acts=acts}) end
  local userface = self.user.menu.top  -- and not self.user.admin
  if not guest and (not userface or userface == "menu") then 
      menu = items.start and items.start[2] or '' -- hide menu items in header if userface = menu
  end

  local footer = self.conf.footer or "yoke &copy; luamani@yahoo.com"
  if guest then
    qry = "select content from pages where active=1 and id='footer'"
    for content in self.conn:urows(qry) do
      footer = content
    end
  end

  local ht = not cli and db.index(self) or {}
  if self.conf.autologin or self.user.menu.top then
    door = ''
  end

  if not door then door = self.util:sub(ht.door,{login=login,exit=exit}) end

  return self.util:sub(ht.page,{
    index = self.conf.idx,
    path = path,
    logo = logo,
    slogan = face and face.slogan
                and concat{path,"/face/",face[1],"/img/",face.slogan} or "",
    header = menu,
    door = door,
--
    title = self.conf.title or db[1],
    lang = self.conf.lang or "en",
    loading = lang.Loading or "",
    nav = nav,
    --menu = menu,
    acts = '',
    finder = finder,
    content = content,
    footer = footer,
--
    noscript = self.conf.js and noscript or '',
    face = cssface,
    css = concat(css,"\n"),
    lib = concat(lib,"\n"),
    js = self.conf.js and concat(js,"\n") or "",
    keywords = self.conf.meta and self.conf.meta.keywords or "lua framework,crm,cms,erp",
    description = self.conf.meta and self.conf.meta.description or "lua based web tools",
    icon = face and face.icon or concat{path,"/site/face/favicon.png"},
  })
end

function db:enter()
  local cli = self.conf.cli
  local ht = not cli and db.index(self) or {}
  local items = {}
  local item = nil
  local js = self.conf.js
  local apps = self.conf.apps
  local home = self.user.home or self.conf.home
--
  local qry = {"select rowid,id,name,access,menu from pages ",
      "where active = 1 and access >= 1 and menu+0 > 0 "}
  if not self.user.admin then
      qry = {"select rowid,id,name,access,menu from pages ",
      "where active = 1 and access = 2 and menu+0 > 0 "}
  end
  if self.user then
    if not self.user.admin or (self.user.pages or "") ~= "" then
      local pages = {}
      for pg in string.gmatch(self.user.pages or "","(%w+):0") do pages[#pages+1] = pg end --todo site pages cli
        if #pages > 0 then
          insert(qry,concat{" and id not in ('",concat(pages,"','"),"')"})
        end
    end
    insert(qry," order by menu")

    for rowid,id,name,access,menu in self.conn:urows(concat(qry)) do
      item = {id,name,self:href(id,lang[name] or name),menu or 0}
      if id == home and not items.start then
        items.start = item
      elseif not items.start or items.start[1] ~= id then
        --insert(items,cli and item or self:href(id,lang[name] or name))
        insert(items,item)
      end
    end
  end -- if user

  local userface = self.user.menu.top -- and not self.user.admin

  if #items > 0 and not userface and not cli then
      insert(items,{0,'',"<hr noshade='noshade' size='1'/>"})
  end

  self:apps(items)
  local start = items.start and items.start[1] and
        self:link(items.start[1],lang[items.start[2]] or items.start[2],nil,'nodeco',
          not userface and "<font color='#ffaa00'>&#9679;</font>&#160;&#160;" or nil) or ""

  local admin = self.user.admin and concat{"<hr noshade='noshade' size='1'/>",
                self:link("users",lang.Admin or "Admin",nil,"nodeco")} or ""

  local login = self:link('metas',self.user.login or "nologin",nil,'nodeco')
  local exit = self:href('login',lang.Exit or 'Exit') --self:link('login',lang.Exit or "Exit",nil,'nodeco')

  local door = self.util:sub(ht.door,{login=login,exit=exit})

  local menu = items

  if not cli then -- menu
    for k,v in ipairs(items) do items[k] = concat{"<li>",v[3] or '',"</li>"} end
    start = concat{"<li>",start,"</li>"}
    if not userface then
      insert(items,concat{"<div>",start,"</div>"})
      insert(items,concat{"<div>",admin,"</div>"})
    else
      insert(items,start)
    end
    if not self.conf.autologin and self.user.menu.top then
      insert(items,concat{"<li>",login,"</li>"})
      insert(items,concat{"<li>",exit,"</li>"})
    end
    --menu = concat(items,userface and "<span style='margin-left:15px;'/>" or "")
    menu = concat{'<ul class="visible-links">',concat(items),"</ul>",'<ul class="hidden-links hidden"></ul>'}
  end

  local nav = not userface and self.util:sub(ht.nav,{menu=menu,acts=''}) or ""

  return {menu,items.start,door,nav}
end

function db:login(start)
  if params.act == 'exit' then start = true end
  return self:page('login',start) -- no xml = true
end

function db:href(id,name,guest,onepage)
  local path = self.conf.path
  local popup = self:link("popup",concat{"<img border='0' src='",path,"/site/face/img/plus.png' alt='+'/>"},
                          {mod=id,act='new'})
  local new = self:link(id,concat{"<img border='0' src='",path,"/site/face/img/plus.png' alt='+'/>"},{act='new'})
  if id == 'login' then
    return concat{"<a class='nodeco' href='",self.conf.idx,"?mod=login&act=exit&lynx=true'>",name,"</a>"}
  elseif guest or self.user.menu.top then --userface
    if onepage then
      return concat{"<a class='nodeco' href='",self.conf.idx,"#",id,"'>",name,"</a>"}
    else
      return concat{self:link(id,name,nil,'nodeco')}
    end
  else
    return concat{"<li>",new,"&#160;&#160;",self:link(id,name,nil,'nodeco'),"</li>"}
  end
end

function db.index(self)
  local html = {
  page=[[
<!DOCTYPE html>
<html xmlns="http://www.w3.org/1999/xhtml">
    <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1,user-scalable=yes">
    $noscript
    <title>$title</title>
    <meta name="keywords" content="$keywords"/>
    <meta name="description" content="$description"/>
    <link rel='shortcut icon' href='$icon'/>
    $lib
    <link rel='stylesheet' href='$face' type='text/css'/>
    <link rel='stylesheet' href='$path/site/face/css/date.css' type='text/css'/>
    <link rel="stylesheet" href="$path/site/face/css/jodit.css"/>
    $css
    <script type='text/javascript' src='$path/site/face/js/jquery.js'></script>
    <script type='text/javascript' src='$path/site/face/js/jquery.history.js'></script>
    <script type='text/javascript' src='$path/site/face/js/date/date.js'></script>
    <script type='text/javascript' src='$path/site/face/js/yoke.js'></script>
    <script type='text/javascript' src='$path/site/face/js/date/$lang.js'></script>
    <script src="$path/site/face/js/jodit.js"></script>
    <!--[if lt IE 9]>
     <script src="$path/site/face/js/html5shiv.js"></script>
    <![endif]-->

    </head>
  <body>
  <header class="header">
      <div id="slogan" style="background-image: url('$slogan');"></div>
      <div id="logo"><a href='$index'>
        <img height="30px" border="0" src='$logo' alt=''/></a>
      </div>
      <div id="header" class="main-nav">
        <button><div class="more"></div></button>
        $header&#160;
      </div>
      $door
  </header>
  <div id="content">
    <div id="nav">$nav</div>
    <article>
      <section id="adm"></section>
      <section id="fnd">$finder</section>

      <section id="acts">$acts</section>

      <section id="frm">$content</section>
      <section id="alert"></section>
    </article>

  </div>

  <footer><div>$footer</div></footer>

  <span id='loading'>$loading</span>
  <span id='spanSuggest' class="suggest"></span>

  <iframe id="fload" name="fload" style="display:none">&#160;</iframe>
  $js
  </body>
  </html>
  ]],

  door = [[
    <div id="door" style="position:absolute;top:0;right:0;">
      <div style="float:left;"><font color='ffaa00'>&#9679;</font><span style="margin-left:10px;"/>$login</div>
      <div style="white-space:nowrap;">$exit</div>
    </div>
  ]],
  nav = [[
    <nav>
      <section>
        <hr noshade="noshade" size="1"/>
        <div id='menu'><ul>$menu</ul></div>
      </section>
      <section>
        <hr noshade="noshade" size="1"/>
        <ul id="acts">$acts</ul>
        <hr noshade="noshade" size="1"/>
      </section>
      <script>$("#slogan").hide()</script>
    </nav>
  ]]

  }

  local user = self.user and self.user.id
  if self.conf.noindex or user then return html end -- no use index.html

  local face = self.conf.face or "/"
  if type(face) == "table" then face = concat{"/",face[1]} end
  local idx = concat{self.conf.path,'/face/',face,'/index.html'}

  local ht = loadfile(idx)

  if not ht then
    local fd = io.open(idx,"r")
    if not fd then
      fd = io.open(idx,"w")
      if fd then
        fd:write(concat{"return {\npage = [[",html.page,
        "]],\n door = [[",html.door,
        "]],\n nav = [[",html.nav,"]]}\n"})
        fd:close()
      end
    end
  end
  return ht and ht() or html
end

return db
