-----------------------
-- yoke © yokerp.com --
-----------------------

local format,concat,insert = string.format,table.concat,table.insert
local jscalls = [[<script type='text/javascript'>%s</script>]]
local db = {}

function db:run()
  local jscall = ''
  local conf = self.conf or require('conf')
  local JS = loadfile(concat{conf.root,'/yoke/site/face/js/popup.js'})()
  local act = params.act or ""
  local title = params.title or ""
  local mod = params.mod or ""
  local refsel = params.refsel or ""
  local refrm = params.refrm or ""
  local refld = params.refld or "x"
  local ids = params.fn or ''
  local shift = params.shift and format("[%s]",params.shift) or "" -- for tr
  if refsel and refsel ~= "" or refrm and refrm ~= "" then
    jscall = format(jscalls,format([[acall("%s",{act:"find",refsel:"%s",refld:"%s",fn:"%s",
        select:"%s",refid:"%s",ask:"%s",refrm:"%s"%s})]],
      mod,refsel,refld,ids,params.select and 1 or 0,
      params.refid or '',params.ask or "",refrm or "",params.any and ',any:"1"' or ''))
  elseif mod ~= "" then
    local json = ""
    if params.recno then
      if act == "" then act = "show" end
      if params.paper then
        json = format([[,{act:"%s",recno:"%s",paper:"1"}]],act,params.recno)
      else
        json = format([[,{act:"%s",recno:"%s",prn:"%s"}]],act,params.recno,params.prn or "")
      end
    elseif act ~= "" then
      local get = {}
      for k,v in pairs(params) do
        if v and v ~= '' and type(v) ~= 'table' and k ~= 'popup' and k ~= 'mod' then
          get[#get+1] = concat{k,':"',v,'"'}
        end
      end
      --json = format([[,{act:"%s",report:"%s"}]],act,params.report)
      json = concat{',{',concat(get,','),'}'} --todo
    end
    jscall = format(jscalls,format("acall('%s'%s);",mod,json))
  end

  local js,jsed = "",""
  if mod == "convert" then
    js = JS.vertical
  elseif mod == "forms" or params.paper then
    jsed = require("yoke.site.apps.page.mods.forms"):jsed(nil,nil,conf.idx)
  elseif act == "map" then
    js = (params.fld=="geocode" or params.fld=="street") and JS.geocode or JS.route
    js = string.gsub(js,"%$([%d%w]+)",{lang = conf.lang or 'en'})
  elseif act == "cam" then
    local bg = params.refrm
    js = JS.camera
    js = string.gsub(js,"%$([%d%w]+)",{lang = conf.lang or 'en'})
    jsed = format([[
    <div id="cam-container">
      <div id="vid-container">
        <video id="video" autoplay playsinline></video>
        <div id="video-overlay">
            <img src="%s" height="100%%"/>
            <img id="snapshot" src=""/>
        </div>
      </div>
      <div id="gui-controls">
        <button
          id="switchCameraButton"
          name="switch Camera"
          type="button"
          aria-pressed="false"
        ></button>
        <button id="takePhotoButton" name="take Photo" type="button"
                    onclick='javascript:void takeSnapshot("%s")'></button>
        <button
          id="toggleFullScreenButton"
          name="toggle FullScreen"
          type="button"
          aria-pressed="false"
        ></button>
      </div>
    </div>
    ]],bg,refld)
  end
--
  local noscript = "<noscript><meta http-equiv='refresh' content='0; lynx.lua'/></noscript>"
  local guest = false
  if not self.user or not self.user.id then
    guest = true
  end
  local path = conf.path
  local lib = {}
  local face = nil
  for aid,app in pairs(self.conf.apps) do
    if app.face and app.face.lib then
      lib[#lib + 1] = app.face.lib
    end
    if app.face then
      face = {aid,app.face[2]}
    end
  end

  local css,js = {},{js}
  local cssface = concat{path,"/site/face/css/yoke.css"}

  if face and type(face) == "table" and face[1] then
    for _,val in ipairs(face[2] or {}) do
          local cssfile = concat{"apps/",face[1],"/face/css/",val,".css"}
          if io.open(cssfile) then
            css[#css+1] = concat{"<link rel='stylesheet' href='",cssfile,"' type='text/css'/>"}
          end
          local jsfile = concat{"apps/",face[1],"/face/js/",val,".js"}
          if io.open(jsfile) then
            js[#js+1] = concat{"<script type='text/javascript' src='",jsfile,"'></script>"}
          end
    end
    local cssfile = concat{"apps/",face[1],"/face/css/yoke.css"}
    if io.open(cssfile) then
      cssface = cssfile
    end
  end


  local html = string.gsub(self.html.page,"%$([%d%w]+)",{
    path = path,
    title= title,
    lang = conf.lang,
    refrm = refrm,
    refld = refld,
    ids = ids,
    shift = shift,
    jscall = jscall,
    jsed = jsed,
--
    noscript = conf.js and noscript or '',

    face = cssface,
    css = concat(css,"\n"),
    lib = concat(lib,"\n"),
    js = conf.js and concat(js,"\n") or "",
    lang = conf.lang or 'en',
  })

  return html
end

db.html = {
page = [[
<!DOCTYPE html>
  <html xmlns="http://www.w3.org/1999/xhtml">
    <head>
    <meta charset="utf-8">
    <meta http-equiv="X-UA-Compatible" content="IE=edge">
    <meta name="viewport" content="width=device-width, initial-scale=1,user-scalable=yes">
    $noscript
    <title>$title</title>
    <meta name="keywords" content="crm,cms,lua"/>
    <meta name="description" content="Network copybook"/>
    $lib
    <link rel='stylesheet' href='$face' type='text/css'/>
    <link rel='stylesheet' href='$path/site/face/css/date.css' type='text/css'/>
    <link rel="stylesheet" href="$path/site/face/css/jodit.css"/>
    $css
    <script type='text/javascript' src='$path/site/face/js/jquery.js'></script>
    <script type='text/javascript' src='$path/site/face/js/jquery.history.js'></script>
    <script type='text/javascript' src='$path/site/face/js/date/date.js'></script>
    <script type='text/javascript' src='$path/site/face/js/yoke.js'></script>
    <script type='text/javascript' src='$path/site/face/js/date/$lang.js'></script>
    <script src="$path/site/face/js/jodit.js"></script>

    <!--[if lt IE 9]>
     <script src="$path/site/face/js/html5shiv.js"></script>
    <![endif]-->

<script language="JavaScript">
function dorefsel (oid,val,select) {
  var frm = opener.document.forms['$refrm'];
  if(frm != undefined){
    if(select==0){
      var mod = '$refld'.split('.');
      var ids = '$ids'.split(',');
      var vals = val.split(',');
      frm['$refld']$shift.value = vals[0];
      frm['$refld'+'Id']$shift.value = oid;
      if(ids.length == vals.length)
        for(i=1;i<ids.length;i++) frm[mod[0]+"."+mod[1]+"."+ids[i] ]$shift.value = vals[i];
    }else{
      frm['$refld'].options[0].value = oid;
      frm['$refld'].options[0].innerHTML = val;
      frm['$refld'].selectedIndex=0;
    }
    window.opener.$(frm['$refld']$shift).trigger('change');
  }
  window.close();
};
</script>
</head>
<body style="padding:0;margin:auto;">


<span id='loading'>
Loading...
</span>
<span id='spanSuggest' class="suggest"></span>
<!--<header id="title"></header>-->
<div id="content">
  <section id="fnd"></section>
  <section id="frm">$jsed</section>
</div>

$jscall
$js

<iframe id="fload" name="fload" style="display:none">&#160;</iframe>
</body>
</html>
]],
}

return db
